Description

The chroot package builder tools in Libretools is inflexible in many ways. Even if some of these are configurable or fixable, they are
default behaviour:

e Hard-coded files. Examples:
o mirrorlist
Librechroot uses arch-nspawn to forcefully set the host mirror with hard-coded paths - https:/labs.parabola.nu/issues/623
o BUILDDIR="/build"
o srcdest and pkgdest
Document or remove how/why the tools mangle configuration files - https:/labs.parabola.nu/issues/256
* The complexity limits hacking to knowledgeable people.
As an example, the attached file shows a libremakepkg process tree. Building without a chroot only requires makepkg.
¢ clean-pkgs, which | believe runs every time before a package is built, removes chroot packages which are not (recursive)
dependencies of the package to be built.
e There are no Libretools commands to make changes inside the master chroot, or it's not documented (l/ibrechroot -/ could work).
¢ To build a package, the current directory must be in the abslibre tree controlled by Libretools. However, releasing packages
does not allow uncommited files, so the tree can't be used for programming or testing.

| can recognize two different purposes of chroot package building tools like librechroot and libremakepkg: automation of package
building on clean chroots, and validation of packages to respect packaging policy. Libretools seems to be focused on validation and
following packaging policy, but not on providing clean chroots to aid the creation of packages. Maybe global validation/release and
testing modes can be added to fill these separate purposes.

History

#1 - 2015-01-19 07:20 AM - fauno

+1 to the subject, i lost track of libretools long time ago :P

#2 - 2015-04-13 10:18 PM - lukeshu

Ping me on IRC so we can discuss this.

fauno: yeah, but you lost track way back when xihh was still developing it :P

#3 - 2015-05-18 01:09 AM - lukeshu

There are no Libretools commands to make changes inside the master chroot, or it's not documented (librechroot -l could work).

That is the intended way to do it. -l root. | guess | thought with the way the documentation was, that would be clear. What would be a good way of
clarifying the docs?

#4 - 2016-04-15 04:10 AM - lukeshu

BUILDDIR="/build"

FWIW, Debian later standardized on this for reproducible builds. Beating Debian to the punch, since 2015 :P

#5 - 2016-04-15 11:07 PM - lukeshu
- Priority changed from wish to discussion

- Subject changed from Purpose and rigidity of librechroot/libremakepkg and related tools to [RFC] Purpose and rigidity of librechroot/libremakepkg
and related tools

#6 - 2016-04-16 11:04 PM - alfplayer

Hacking documents could really help with this, and/or source file comments, to describe important processes, commands, file paths and maybe
functions.

#7 - 2018-10-02 05:34 PM - lukeshu

- Status changed from open to not-a-bug

I'm going to go ahead and close this. There's been no discussion in 2 years. The mirrorlist bit is the only part | still think is valid; and #623 is open for
it.

Files

libremakepkg-process-tree 665 Bytes 2015-01-19 alfplayer
